<?php
// +----------------------------------------------------------------------
// | Redis调用类
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------


class RpcRedis
{
    private static $instance = null; // 创建静态对象变量,用于存储唯一的对象实例  
    private function __construct(){} // 私有化构造函数，防止外部调用
    private function __clone(){}     // 私有化克隆函数，防止外部克隆对象
	/**
	 * Redis实例
	*/
	private static $redis_obj;
	/**
	 * 前缀
	*/
	private static $prefix;
    
    /**
     * 实例化对象方法，供外部获得唯一的对象
     * @todo 无
     * @author 小黄牛
     * @version v1.0.1 + 2020.06.08
     * @deprecated 暂不启用
     * @global 无
     * @return RpcRedis
    */
    public static function run(){
        if (empty(self::$instance)) {
			$obj = new RpcRedis();
			// 启动Redis连接
			$obj::start();
			self::$instance = $obj;
		}
		return self::$instance;
    }
    
    /**
	 * 初始化Redis连接
	 * @todo 无
	 * @author 小黄牛
	 * @version v1.0.1 + 2020.06.08
	 * @deprecated 暂不启用
	 * @global 无
	 * @return void
	*/
	private static function start() {
		try {
			$config = require 'config/rpc.php';
			$redis = new Redis(); 
			$redis->connect($config['host'], $config['port'], $config['outtime']);
			$redis->auth($config['password']);
			self::$redis_obj = $redis;
			self::$prefix = $config['prefix'];
		}catch (RedisException $e) { 
			$err = array(
				'code' => $e->getCode(), 
				'msg'  => $e->getMessage(), 
				'file'    => $e->getFile(), 
				'line'   => $e->getLine() 
			);
			var_dump($err); 
		}
	}

	/**
     * 事件注入
     * @todo 无
     * @author 小黄牛
     * @version v1.0.1 + 2020.06.08
     * @deprecated 暂不启用
     * @global 无
     * @return void
    */
    public function __call($name, $arguments=array()) {
        if (!self::$redis_obj) return false;
        if (empty($name)) return false;

        $ref = new \ReflectionClass(self::$redis_obj);
        if (!$ref->hasMethod($name)) return false;

		// 加上前缀
		if ($name == 'rawCommand') {
			if (isset($arguments[1])) {
				$arguments[1] = self::$prefix.$arguments[1];
			}
		} else {
			if (isset($arguments[0])) {
				$arguments[0] = self::$prefix.$arguments[0];
			}
		}
		$obj = $ref->getmethod($name);
		$ret = $obj->invokeArgs(self::$redis_obj, $arguments);

		return $ret;
    }
}